\ tag: forth bootstrap starter.
\ 
\ Copyright (C) 2003 Patrick Mauritz, Stefan Reinauer
\ 
\ See the file "COPYING" for further information about
\ the copyright and warranty status of this work.
\ 

include bootstrap.fs        \ all base words
include interpreter.fs      \ interpreter
include builtin.fs          \ builtin terminal.

: banner
  s" OpenBIOS kernel started." type cr
  ;

: bye 
  s" Farewell!" cr type cr cr 
  0 rdepth! 
  ;

\ quit starts the outer interpreter of the forth system.
\ zech describes quit as being the outer interpreter, but
\ we split it apart to keep the interpreter elsewhere.

: quit                      ( -- )
  2 rdepth!
  banner
  outer-interpreter
  ;

\ initialize is the first forth word run by the kernel.
\ this word is automatically executed by the C core on start 
\ and it's never left unless something goes really wrong or
\ the user decides to leave the engine.

: initialize                ( startmem endmem -- )
  over - init-mem
  init-pockets
  init-builtin-terminal
  quit
  ;
