\ tag: simple forth tests
\ 
\ Copyright (C) 2003 Patrick Mauritz, Stefan Reinauer
\ 
\ See the file "COPYING" for further information about
\ the copyright and warranty status of this work.
\ 

: greeting 
  s" OpenBIOS" type cr
  s" ok " type cr
  ;

: test-if
  0 if 64 else 65 then
  1 if 66 else 67 then
  . .
  ;

: test-doloop 
  80 70 do 
    i .
  loop 
  cr
  60 60 do 
    i .
  loop 
  cr
  50 50 ?do
    i .
  loop
  cr
  0 0 ?do
    i .
  loop
  cr
  60 50 ?do
    i .
  loop
  cr 
  ;

: test-beginagain
  begin 
    40 emit 
  again 
  cr
  ;

: test-beginuntil
  80 begin 
    dup emit 
    1 - 
    dup 40 = 
  until 
  drop cr
  ;

: test-while
  80 
  begin 
    dup emit 
    dup 41 > 
  while 
    1 - 
  repeat 
  drop cr
  ;

: test-case
  63 emit 61 emit 73 emit 65 emit 20 emit
  2 case 
   1 of 31 emit cr endof 
   2 of 32 emit cr endof 
   3 of 33 emit cr endof 
  endcase
  cr
  ;

: test-case2
   1
   case
   0 of   true  endof
   1 of   false endof
   2 of   drop false endof
   endcase
   .s
;


: test-exit
  true if exit then s" foo" type cr
  ;


: test-spaces
  space
  40 emit
  8 spaces
  40 emit
  cr
  ;

: ascii
  cr
  7f 20 do
    i dup 
    16 + swap
    do  i emit loop
    cr
  16 +loop cr
  ;

: test-dump
  here 80 - 48 dump
  ;

: test-simple
  test-if
  test-spaces
  test-doloop
  test-beginuntil
  test-while
  test-case
  test-dump
  ;

defer test-defer

: test-suite 
  greeting
  fract
  words
  \ ascii
  ['] ascii ['] test-defer (to)
  test-defer
  test-simple cr
  ;



