/* stack.h
 * tag: stack and stack access functions
 *
 * Copyright (C) 2003 Patrick Mauritz, Stefan Reinauer
 *
 * See the file "COPYING" for further information about
 * the copyright and warranty status of this work.
 */

#ifndef __STACK_H
#define __STACK_H

#define dstacksize 512
extern int32_t dstackcnt;
extern cell dstack[dstacksize];

#define rstacksize 512
extern int32_t rstackcnt;
extern cell rstack[rstacksize];


static inline void PUSH(ucell value)
{
	dstack[++dstackcnt] = (value);
}

#ifndef NATIVE
static inline ucell POP(void)
{
	return (ucell) dstack[dstackcnt--];
}
#endif

#if !defined(HOSTED) && !defined(NATIVE)
static inline void DPUSH(ducell value)
{
	dstack[++dstackcnt] = (cell) value;
	dstack[++dstackcnt] = (cell) (value >> bitspercell);
}

static inline ducell DPOP(void)
{
	ducell du;
	du = ((ducell) ((ucell) dstack[dstackcnt--]) << bitspercell);
	du |= (ucell) dstack[dstackcnt--];
	return du;
}

static inline ucell GETTOS(void)
{
	return dstack[dstackcnt];
}

#define GETITEM(number) (dstack[dstackcnt - number])
static inline void PUSHR(ucell value)
{
	rstack[++rstackcnt] = (value);
}

static inline ucell POPR(void)
{
	return (ucell) rstack[rstackcnt--];
}
static inline ucell GETTORS(void)
{
	return rstack[rstackcnt];
}

#endif


#ifdef DEBUG_DSTACK
void printdstack(void);
#endif
#ifdef DEBUG_RSTACK
void printrstack(void);
#endif

#endif
