/* tag: defines the stacks, program counter and ways to access those
 *
 * Copyright (C) 2003 Patrick Mauritz, Stefan Reinauer
 *
 * See the file "COPYING" for further information about
 * the copyright and warranty status of this work.
 */


#include "config.h"
#include "types.h"

#define dstacksize 512
int32_t dstackcnt = 0;
cell dstack[dstacksize];

#define rstacksize 512
int32_t rstackcnt = 0;
cell rstack[rstacksize];

void printk(const char *format, ...);
#ifdef DEBUG_DSTACK
void printdstack(void)
{
	int i;
	printk("dstack:");
	for (i = 0; i <= dstackcnt; i++) {
		printk(" 0x%x", dstack[i]);
	}
	printk("\n");
}
#endif
#ifdef DEBUG_RSTACK
void printrstack(void)
{
	int i;
	printk("rstack:");
	for (i = 0; i <= rstackcnt; i++) {
		printk(" 0x%x", rstack[i]);
	}
	printk("\n");
}
#endif
